diff --git a/web/pgadmin/misc/bgprocess/__init__.py b/web/pgadmin/misc/bgprocess/__init__.py
index e3bd8cbf4..675d3fe55 100644
--- a/web/pgadmin/misc/bgprocess/__init__.py
+++ b/web/pgadmin/misc/bgprocess/__init__.py
@@ -39,7 +39,7 @@ class BGProcessModule(PgAdminModule):
         return [
             'bgprocess.status', 'bgprocess.detailed_status',
             'bgprocess.acknowledge', 'bgprocess.list',
-            'bgprocess.stop_process'
+            'bgprocess.stop_process', 'bgprocess.update_cloud_details',
         ]
 
 
@@ -88,6 +88,26 @@ def acknowledge(pid):
     """
     User has acknowledge the process
 
+    Args:
+        pid:  Process ID
+
+    Returns:
+        Positive status
+    """
+    try:
+        BatchProcess.acknowledge(pid)
+        return success_return()
+    except LookupError as lerr:
+        return gone(errormsg=str(lerr))
+
+
+@blueprint.route('/update_cloud_details/<pid>', methods=['PUT'],
+                 endpoint='update_cloud_details')
+@login_required
+def update_cloud_details(pid):
+    """
+    Update the cloud details and get instance details
+
     Args:
         pid:  Process ID
 
@@ -96,7 +116,7 @@ def acknowledge(pid):
     """
     try:
         process = BatchProcess(id=pid)
-        status, server = process.acknowledge(pid)
+        status, server = process.update_cloud_details()
         if status and len(server) > 0:
             return make_json_response(
                 success=1,
diff --git a/web/pgadmin/misc/bgprocess/processes.py b/web/pgadmin/misc/bgprocess/processes.py
index 2510cc29d..b5ad4680a 100644
--- a/web/pgadmin/misc/bgprocess/processes.py
+++ b/web/pgadmin/misc/bgprocess/processes.py
@@ -16,17 +16,19 @@ import os
 import sys
 import psutil
 from abc import ABCMeta, abstractproperty, abstractmethod
-from datetime import datetime
+from datetime import datetime, timedelta
 from pickle import dumps, loads
 from subprocess import Popen, PIPE
 import logging
 import json
+import shutil
 
 from pgadmin.utils import u_encode, file_quote, fs_encoding, \
     get_complete_file_path, get_storage_directory, IS_WIN
 from pgadmin.browser.server_groups.servers.utils import does_server_exists
 from pgadmin.utils.constants import KERBEROS
 from pgadmin.utils.locker import ConnectionLocker
+from pgadmin.utils.preferences import Preferences
 
 import pytz
 from dateutil import parser
@@ -463,8 +465,9 @@ class BatchProcess(object):
         idx = 0
         c = re.compile(r"(\d+),(.*$)")
 
+        # If file is not present then
         if not os.path.isfile(logfile):
-            return 0, False
+            return 0, True
 
         with open(logfile, 'rb') as f:
             eofs = os.fstat(f.fileno()).st_size
@@ -496,10 +499,20 @@ class BatchProcess(object):
 
         return pos, completed
 
-    def _get_cloud_instance_details(self, _process):
+    def update_cloud_details(self):
         """
         Parse the output to get the cloud instance details
         """
+        _server = {}
+        _pid = self.id
+
+        _process = Process.query.filter_by(
+            user_id=current_user.id, pid=_pid
+        ).first()
+
+        if _process is None:
+            raise LookupError(PROCESS_NOT_FOUND)
+
         ctime = get_current_time(format='%y%m%d%H%M%S%f')
         stdout = []
         stderr = []
@@ -507,7 +520,6 @@ class BatchProcess(object):
         err = 0
         cloud_server_id = 0
         cloud_instance = ''
-        pid = self.id
 
         enc = sys.getdefaultencoding()
         if enc == 'ascii':
@@ -527,20 +539,20 @@ class BatchProcess(object):
                     cloud_instance = json.loads(value[1])
                     cloud_server_id = _process.server_id
 
-                if type(cloud_instance) is dict and\
+                if type(cloud_instance) is dict and \
                         'instance' in cloud_instance:
                     cloud_instance['instance']['sid'] = cloud_server_id
                     cloud_instance['instance']['status'] = True
-                    cloud_instance['instance']['pid'] = pid
+                    cloud_instance['instance']['pid'] = _pid
                     return update_server(cloud_instance)
         elif err_completed and _process.exit_code > 0:
             cloud_instance = {'instance': {}}
             cloud_instance['instance']['sid'] = _process.server_id
             cloud_instance['instance']['status'] = False
-            cloud_instance['instance']['pid'] = pid
+            cloud_instance['instance']['pid'] = _pid
             return update_server(cloud_instance)
         else:
-            clear_cloud_session(pid)
+            clear_cloud_session(_pid)
         return True, {}
 
     def status(self, out=0, err=0):
@@ -695,8 +707,23 @@ class BatchProcess(object):
         processes = Process.query.filter_by(user_id=current_user.id)
         changed = False
 
+        browser_preference = Preferences.module('browser')
+        expiry_add = timedelta(
+            browser_preference.preference('process_retain_days').get() or 1
+        )
+
         res = []
-        for p in processes:
+        for p in [*processes]:
+            if p.start_time is not None:
+                # remove expired jobs
+                process_expiration_time = \
+                    parser.parse(p.start_time) + expiry_add
+                if datetime.now(process_expiration_time.tzinfo) >= \
+                        process_expiration_time:
+                    shutil.rmtree(p.logdir, True)
+                    db.session.delete(p)
+                    changed = True
+
             status, updated = BatchProcess.update_process_info(p)
             if not status:
                 continue
@@ -708,11 +735,6 @@ class BatchProcess(object):
             ):
                 continue
 
-            if BatchProcess._operate_orphan_process(p):
-                continue
-
-            execution_time = None
-
             stime = parser.parse(p.start_time)
             etime = parser.parse(p.end_time or get_current_time())
 
@@ -732,6 +754,8 @@ class BatchProcess(object):
                 'acknowledge': p.acknowledge,
                 'execution_time': execution_time,
                 'process_state': p.process_state,
+                'utility_pid': p.utility_pid,
+                'server_id': p.server_id,
                 'current_storage_dir': current_storage_dir,
             })
 
@@ -740,35 +764,12 @@ class BatchProcess(object):
 
         return res
 
-    @staticmethod
-    def _operate_orphan_process(p):
-
-        if p and p.desc:
-            desc = loads(p.desc)
-            if does_server_exists(desc.sid, current_user.id) is False:
-                current_app.logger.warning(
-                    _("Server with id '{0}' is either removed or does "
-                      "not exists for the background process "
-                      "'{1}'").format(desc.sid, p.pid)
-                )
-                try:
-                    process = BatchProcess(id=p.pid)
-                    process.acknowledge(p.pid)
-                except LookupError as lerr:
-                    current_app.logger.warning(
-                        _("Status for the background process '{0}' could "
-                          "not be loaded.").format(p.pid)
-                    )
-                    current_app.logger.exception(lerr)
-                return True
-
-        return False
-
     @staticmethod
     def total_seconds(dt):
         return round(dt.total_seconds(), 2)
 
-    def acknowledge(self, _pid):
+    @staticmethod
+    def acknowledge(_pid):
         """
         Acknowledge from the user, he/she has alredy watched the status.
 
@@ -776,9 +777,6 @@ class BatchProcess(object):
         And, delete the process information from the configuration, and the log
         files related to the process, if it has already been completed.
         """
-        status = True
-        _server = {}
-
         p = Process.query.filter_by(
             user_id=current_user.id, pid=_pid
         ).first()
@@ -787,16 +785,14 @@ class BatchProcess(object):
             raise LookupError(PROCESS_NOT_FOUND)
 
         if p.end_time is not None:
-            status, _server = self._get_cloud_instance_details(p)
             logdir = p.logdir
             db.session.delete(p)
             import shutil
             shutil.rmtree(logdir, True)
         else:
             p.acknowledge = get_current_time()
-        db.session.commit()
 
-        return status, _server
+        db.session.commit()
 
     def set_env_variables(self, server, **kwargs):
         """Set environment variables"""
@@ -834,13 +830,15 @@ class BatchProcess(object):
             process.terminate()
             # Update the process state to "Terminated"
             p.process_state = PROCESS_TERMINATED
-            db.session.commit()
+        except psutil.NoSuchProcess:
+            p.process_state = PROCESS_TERMINATED
         except psutil.Error as e:
             current_app.logger.warning(
                 _("Unable to kill the background process '{0}'").format(
                     p.utility_pid)
             )
             current_app.logger.exception(e)
+        db.session.commit()
 
     @staticmethod
     def update_server_id(_pid, _sid):
diff --git a/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js b/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js
new file mode 100644
index 000000000..13a4ef9c2
--- /dev/null
+++ b/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js
@@ -0,0 +1,243 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import getApiInstance, { parseApiError } from '../../../../static/js/api_instance';
+import url_for from 'sources/url_for';
+import Notifier from '../../../../static/js/helpers/Notifier';
+import EventBus from '../../../../static/js/helpers/EventBus';
+import * as BgProcessNotify from './BgProcessNotify';
+import showDetails from './showDetails';
+import gettext from 'sources/gettext';
+
+const WORKER_INTERVAL = 1000;
+
+export const BgProcessManagerEvents = {
+  LIST_UPDATED: 'LIST_UPDATED',
+};
+
+export const BgProcessManagerProcessState = {
+  PROCESS_NOT_STARTED: 0,
+  PROCESS_STARTED: 1,
+  PROCESS_FINISHED: 2,
+  PROCESS_TERMINATED: 3,
+  /* Supported by front end only */
+  PROCESS_TERMINATING: 10,
+  PROCESS_FAILED: 11,
+};
+
+
+export default class BgProcessManager {
+  static instance;
+
+  static getInstance(...args) {
+    if (!BgProcessManager.instance) {
+      BgProcessManager.instance = new BgProcessManager(...args);
+    }
+    return BgProcessManager.instance;
+  }
+
+  constructor(pgBrowser) {
+    this.api = getApiInstance();
+    this.pgBrowser = pgBrowser;
+    this._procList = [];
+    this._workerId = null;
+    this._pendingJobId = [];
+    this._eventManager = new EventBus();
+  }
+
+  init() {
+    if (this.initialized) {
+      return;
+    }
+    this.initialized = true;
+    this.startWorker();
+  }
+
+  get procList() {
+    return this._procList;
+  }
+
+  set procList(val) {
+    throw new Error('Property processList is readonly.', val);
+  }
+
+  async startWorker() {
+    let self = this;
+    await self.syncProcesses();
+    /* Fill the pending jobs initially */
+    self._pendingJobId = this.procList.filter((p)=>(p.process_state == BgProcessManagerProcessState.PROCESS_STARTED)).map((p)=>p.id);
+    this._workerId = setInterval(()=>{
+      if(self._pendingJobId.length > 0) {
+        self.syncProcesses();
+      }
+    }, WORKER_INTERVAL);
+  }
+
+  evaluateProcessState(p) {
+    let retState = p.process_state;
+    if((p.etime || p.exit_code !=null) && p.process_state == BgProcessManagerProcessState.PROCESS_STARTED) {
+      retState =  BgProcessManagerProcessState.PROCESS_FINISHED;
+    }
+    if(retState == BgProcessManagerProcessState.PROCESS_FINISHED && p.exit_code != 0) {
+      retState = BgProcessManagerProcessState.PROCESS_FAILED;
+    }
+    return retState;
+  }
+
+  async syncProcesses() {
+    try {
+      let {data: resData} = await this.api.get(url_for('bgprocess.list'));
+      this._procList = resData?.map((p)=>{
+        let processState = this.evaluateProcessState(p);
+        return {
+          ...p,
+          process_state: processState,
+          canDrop: ![BgProcessManagerProcessState.PROCESS_NOT_STARTED, BgProcessManagerProcessState.PROCESS_STARTED].includes(processState),
+        };
+      });
+      this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+      this.checkPending();
+    } catch (error) {
+      console.error(error);
+    }
+  }
+
+  checkPending() {
+    const completedProcIds = this.procList.filter((p)=>{
+      if(![
+        BgProcessManagerProcessState.PROCESS_NOT_STARTED,
+        BgProcessManagerProcessState.PROCESS_STARTED,
+        BgProcessManagerProcessState.PROCESS_TERMINATING].includes(p.process_state)) {
+        return true;
+      }
+    }).map((p)=>p.id);
+    this._pendingJobId = this._pendingJobId.filter((id)=>{
+      if(completedProcIds.includes(id)) {
+        let p = this.procList.find((p)=>p.id==id);
+        BgProcessNotify.processCompleted(p?.desc, p?.process_state, this.openProcessesPanel.bind(this));
+        if(p.server_id != null) {
+          this.updateCloudDetails(p.id);
+        }
+        return false;
+      }
+      return true;
+    });
+  }
+
+  startProcess(jobId, desc) {
+    if(jobId) {
+      this._pendingJobId.push(jobId);
+      BgProcessNotify.processStarted(desc, this.openProcessesPanel.bind(this));
+    }
+  }
+
+  stopProcess(jobId) {
+    this.procList.find((p)=>p.id == jobId).process_state = BgProcessManagerProcessState.PROCESS_TERMINATING;
+    this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+    this.api.put(url_for('bgprocess.stop_process', {
+      pid: jobId,
+    }))
+      .then(()=>{
+        this.procList.find((p)=>p.id == jobId).process_state = BgProcessManagerProcessState.PROCESS_TERMINATED;
+        this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+      })
+      .catch((err)=>{
+        Notifier.error(parseApiError(err));
+      });
+  }
+
+  acknowledge(jobIds) {
+    const removeJob = (jobId)=>{
+      this._procList = this.procList.filter((p)=>p.id!=jobId);
+      this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+    };
+    jobIds.forEach((jobId)=>{
+      this.api.put(url_for('bgprocess.acknowledge', {
+        pid: jobId,
+      }))
+        .then(()=>{
+          removeJob(jobId);
+        })
+        .catch((err)=>{
+          if(err.response?.status == 410) {
+          /* Object not available */
+            removeJob(jobId);
+          } else {
+            Notifier.error(parseApiError(err));
+          }
+        });
+    });
+  }
+
+  viewJobDetails(jobId) {
+    showDetails(this.procList.find((p)=>p.id==jobId));
+  }
+
+  updateCloudDetails(jobId) {
+    this.api.put(url_for('bgprocess.update_cloud_details', {
+      pid: jobId,
+    }))
+      .then((res)=>{
+        let _server = res.data?.data?.node;
+        if(!_server) {
+          Notifier.error(gettext('Cloud server information not available'));
+          return;
+        }
+        let  _server_path = '/browser/server_group_' + _server.gid + '/' + _server.id,
+          _tree = this.pgBrowser.tree,
+          _item = _tree.findNode(_server_path);
+
+        if (_item) {
+          if(_server.status) {
+            let _dom = _item.domNode;
+            _tree.addIcon(_dom, {icon: _server.icon});
+            let d = _tree.itemData(_dom);
+            d.cloud_status = _server.cloud_status;
+            _tree.update(_dom, d);
+          }
+          else {
+            _tree.remove(_item.domNode);
+            _tree.refresh(_item.domNode.parent);
+          }
+        }
+      })
+      .catch((err)=>{
+        if(err.response?.status != 410) {
+          Notifier.error(gettext('Failed Cloud Deployment.'));
+        }
+      });
+  }
+
+  recheckCloudServer(sid) {
+    let self = this;
+    let process = self.procList.find((p)=>p.server_id==sid);
+    if(process) {
+      this.updateCloudDetails(process.id);
+    }
+  }
+
+  openProcessesPanel() {
+    let processPanel = this.pgBrowser.docker.findPanels('processes');
+    if(processPanel.length > 0) {
+      processPanel = processPanel[0];
+    } else {
+      let propertiesPanel = this.pgBrowser.docker.findPanels('properties');
+      processPanel = this.pgBrowser.docker.addPanel('processes', window.wcDocker.DOCK.STACKED, propertiesPanel[0]);
+    }
+    processPanel.focus();
+  }
+
+  registerListener(event, callback) {
+    this._eventManager.registerListener(event, callback);
+  }
+
+  deregisterListener(event, callback) {
+    this._eventManager.deregisterListener(event, callback);
+  }
+}
diff --git a/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx b/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx
new file mode 100644
index 000000000..850d77c0e
--- /dev/null
+++ b/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx
@@ -0,0 +1,98 @@
+import { Box, makeStyles } from '@material-ui/core';
+import React from 'react';
+import Notifier from '../../../../static/js/helpers/Notifier';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import { DefaultButton, PgIconButton } from '../../../../static/js/components/Buttons';
+import clsx from 'clsx';
+import DescriptionOutlinedIcon from '@material-ui/icons/DescriptionOutlined';
+import { BgProcessManagerProcessState } from './BgProcessManager';
+import PropTypes from 'prop-types';
+import gettext from 'sources/gettext';
+
+
+const useStyles = makeStyles((theme)=>({
+  container: {
+    borderRadius: theme.shape.borderRadius,
+    padding: '0.25rem 1rem 1rem',
+    minWidth: '325px',
+    ...theme.mixins.panelBorder.all,
+  },
+  containerHeader: {
+    height: '32px',
+    display: 'flex',
+    justifyContent: 'space-between',
+    fontWeight: 'bold',
+    alignItems: 'center',
+    borderTopLeftRadius: 'inherit',
+    borderTopRightRadius: 'inherit',
+  },
+  containerBody: {
+    marginTop: '1rem',
+  },
+  containerSuccess: {
+    borderColor: theme.palette.success.main,
+    backgroundColor: theme.palette.success.light,
+  },
+  iconSuccess: {
+    color: theme.palette.success.main,
+  },
+  containerError: {
+    borderColor: theme.palette.error.main,
+    backgroundColor: theme.palette.error.light,
+  },
+  iconError: {
+    color: theme.palette.error.main,
+  },
+}));
+
+function ProcessNotifyMessage({title, desc, onClose, onViewProcess, success=true, dataTestSuffix=""}) {
+  const classes = useStyles();
+  return (
+    <Box className={clsx(classes.container, (success ? classes.containerSuccess : classes.containerError))} data-test={"process-popup-" + dataTestSuffix}>
+      <Box display="flex" justifyContent="space-between" className={classes.containerHeader}>
+        <Box marginRight={'1rem'}>{title}</Box>
+        <PgIconButton size="xs" noBorder icon={<CloseIcon />} onClick={onClose} title={'Close'} className={success ? classes.iconSuccess : classes.iconError} />
+      </Box>
+      <Box className={classes.containerBody}>
+        <Box>{desc}</Box>
+        <Box marginTop={'1rem'} display="flex">
+          <DefaultButton startIcon={<DescriptionOutlinedIcon />} onClick={onViewProcess}>View Processes</DefaultButton>
+        </Box>
+      </Box>
+    </Box>
+  );
+}
+ProcessNotifyMessage.propTypes = {
+  title: PropTypes.string.isRequired,
+  desc: PropTypes.string.isRequired,
+  onClose: PropTypes.func,
+  onViewProcess: PropTypes.func,
+  success: PropTypes.bool,
+  dataTestSuffix: PropTypes.string,
+};
+
+
+export function processStarted(desc, onViewProcess) {
+  Notifier.notify(
+    <ProcessNotifyMessage title={gettext('Process started')} desc={desc} onViewProcess={onViewProcess} dataTestSuffix="start"/>,
+    null
+  );
+}
+
+export function processCompleted(desc, process_state, onViewProcess) {
+  let title = gettext('Process completed');
+  let success = true;
+  if(process_state == BgProcessManagerProcessState.PROCESS_TERMINATED) {
+    title = gettext('Process terminated');
+    success = false;
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_FAILED) {
+    title = gettext('Process failed');
+    success = false;
+  }
+
+  Notifier.notify(
+    <ProcessNotifyMessage title={title} desc={desc} onViewProcess={onViewProcess} success={success} dataTestSuffix="end"/>,
+    null
+  );
+}
+
diff --git a/web/pgadmin/misc/bgprocess/static/js/ProcessDetails.jsx b/web/pgadmin/misc/bgprocess/static/js/ProcessDetails.jsx
new file mode 100644
index 000000000..d62777c08
--- /dev/null
+++ b/web/pgadmin/misc/bgprocess/static/js/ProcessDetails.jsx
@@ -0,0 +1,182 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React, { useState, useMemo } from 'react';
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import { Box, makeStyles } from '@material-ui/core';
+import PropTypes from 'prop-types';
+import { MESSAGE_TYPE, NotifierMessage } from '../../../../static/js/components/FormComponents';
+import { BgProcessManagerProcessState } from './BgProcessManager';
+import { DefaultButton, PgIconButton } from '../../../../static/js/components/Buttons';
+import HighlightOffRoundedIcon from '@material-ui/icons/HighlightOffRounded';
+import AccessTimeRoundedIcon from '@material-ui/icons/AccessTimeRounded';
+import { useInterval } from '../../../../static/js/custom_hooks';
+import getApiInstance from '../../../../static/js/api_instance';
+import pgAdmin from 'sources/pgadmin';
+import FolderSharedRoundedIcon from '@material-ui/icons/FolderSharedRounded';
+
+
+const useStyles = makeStyles((theme)=>({
+  container: {
+    backgroundColor: theme.palette.background.default,
+    height: '100%',
+    display: 'flex',
+    flexDirection: 'column',
+    padding: '8px',
+    userSelect: 'text',
+  },
+  cmd: {
+    ...theme.mixins.panelBorder.all,
+    borderRadius: theme.shape.borderRadius,
+    backgroundColor: theme.otherVars.inputDisabledBg,
+    wordBreak: 'break-word',
+    margin: '8px 0px',
+    padding: '4px',
+  },
+  logs: {
+    flexGrow: 1,
+    borderRadius: theme.shape.borderRadius,
+    padding: '4px',
+    overflow: 'auto',
+    textOverflow: 'wrap-text',
+    margin: '8px 0px',
+    ...theme.mixins.panelBorder.all,
+  },
+  logErr: {
+    color: theme.palette.error.main,
+  },
+  terminateBtn: {
+    backgroundColor: theme.palette.error.main,
+    color: theme.palette.error.contrastText,
+    border: 0,
+    '&:hover': {
+      backgroundColor: theme.palette.error.dark,
+      color: theme.palette.error.contrastText,
+    },
+    '&.Mui-disabled': {
+      color: theme.palette.error.contrastText + ' !important',
+      border: 0,
+    }
+  }
+}));
+
+async function getDetailedStatus(api, jobId, out, err) {
+  let res = await api.get(url_for(
+    'bgprocess.detailed_status', {
+      'pid': jobId,
+      'out': out,
+      'err': err,
+    }
+  ));
+  return res.data;
+}
+
+export default function ProcessDetails({data}) {
+  const classes = useStyles();
+  const api = useMemo(()=>getApiInstance());
+  const [logs, setLogs] = useState(null);
+  const [completed, setCompleted] = useState(false);
+  const [[outPos, errPos], setOutErrPos] = useState([0, 0]);
+  const [exitCode, setExitCode] = useState(data.exit_code);
+  const [timeTaken, setTimeTaken] = useState(data.execution_time);
+
+  let notifyType = MESSAGE_TYPE.INFO;
+  let notifyText = gettext('Not started');
+
+  const process_state = pgAdmin.Browser.BgProcessManager.evaluateProcessState({
+    ...data,
+    exit_code: exitCode,
+  });
+
+  if(process_state == BgProcessManagerProcessState.PROCESS_STARTED) {
+    notifyText = gettext('Running...');
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_FINISHED) {
+    notifyType = MESSAGE_TYPE.SUCCESS;
+    notifyText = gettext('Successfully completed.');
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_FAILED) {
+    notifyType = MESSAGE_TYPE.ERROR;
+    notifyText = gettext('Failed (exit code: %s).', String(exitCode));
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_TERMINATED) {
+    notifyType = MESSAGE_TYPE.ERROR;
+    notifyText = gettext('Terminated by user.');
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_TERMINATING) {
+    notifyText = gettext('Terminating the process...');
+  }
+
+  useInterval(async ()=>{
+    const logsSortComp = (l1, l2)=>{
+      return l1[0].localeCompare(l2[0]);
+    };
+    let resData = await getDetailedStatus(api, data.id, outPos, errPos);
+    resData.out.lines.sort(logsSortComp);
+    resData.err.lines.sort(logsSortComp);
+    if(resData.out?.done && resData.err?.done && resData.exit_code != null) {
+      setExitCode(resData.exit_code);
+      setCompleted(true);
+    }
+    setTimeTaken(resData.execution_time);
+    setOutErrPos([resData.out.pos, resData.err.pos]);
+    setLogs((prevLogs)=>{
+      return [
+        ...(prevLogs || []),
+        ...resData.out.lines.map((l)=>l[1]),
+        ...resData.err.lines.map((l)=>l[1]),
+      ];
+    });
+
+  }, completed ? -1 : 1000);
+
+  const errRe = new RegExp(': (' + gettext('error') + '|' + gettext('fatal') + '):', 'i');
+  return (
+    <Box display="flex" flexDirection="column" className={classes.container} data-test="process-details">
+      <Box data-test="process-message">{data.details?.message}</Box>
+      {data.details?.cmd && <>
+        <Box>{gettext('Running command')}:</Box>
+        <Box data-test="process-cmd" className={classes.cmd}>{data.details.cmd}</Box>
+      </>}
+      {data.details?.query && <>
+        <Box>{gettext('Running query')}:</Box>
+        <Box data-test="process-cmd" className={classes.cmd}>{data.details.query}</Box>
+      </>}
+      <Box display="flex" justifyContent="space-between" alignItems="center" flexWrap="wrap">
+        <Box><span><AccessTimeRoundedIcon /> {gettext('Start time')}: {new Date(data.stime).toString()}</span></Box>
+        <Box>
+          {pgAdmin.server_mode == 'True' && data.current_storage_dir &&
+          <PgIconButton icon={<FolderSharedRoundedIcon />} title={gettext('Storage Manager')} onClick={()=>{
+            pgAdmin.Tools.FileManager.openStorageManager(data.current_storage_dir);
+          }} style={{marginRight: '4px'}} />}
+          <DefaultButton disabled={process_state != BgProcessManagerProcessState.PROCESS_STARTED || data.server_id != null}
+            startIcon={<HighlightOffRoundedIcon />} className={classes.terminateBtn}>Stop Process</DefaultButton></Box>
+      </Box>
+      <Box flexGrow={1} className={classes.logs}>
+        {logs == null && <span data-test="loading-logs">gettext('Loading process logs...')</span>}
+        {logs?.length == 0 && gettext('No logs available.')}
+        {logs?.map((log, i)=>{
+          return <div ref={(el)=>{
+            if(i==logs.length-1) {
+              el?.scrollIntoView();
+            }
+          }} key={i} className={errRe.test(log) ? classes.logErr : ''}>{log}</div>;
+        })}
+      </Box>
+      <Box display="flex" alignItems="center">
+        <NotifierMessage type={notifyType} message={notifyText} closable={false} textCenter={true} style={{flexGrow: 1, marginRight: '8px'}} />
+        <Box>{gettext('Execution time')}: {timeTaken} {gettext('seconds')}</Box>
+      </Box>
+    </Box>
+  );
+}
+
+ProcessDetails.propTypes = {
+  closeModal: PropTypes.func,
+  data: PropTypes.object,
+  onOK: PropTypes.func,
+  setHeight: PropTypes.func
+};
